local defaultsTbl = {
	["Wind Trader"] = {
		["ServiceNPC1"] = true,
		["ServiceNPC2"] = true,
		["ServiceNPC3"] = true,
	},
	["Action Bar"] = {
		["Classical"] = {
			["Action Bar"] = false,
			["Casting Bar"] = false,
		},
		["Horizontal"] = "Mechanical",
		["Rectangular"] = "Darkmoon",
		["Reforge"] = {
			["Bag Slots"] = true,
			["Casting Bar"] = true,
			["Main Bar"] = true,
			["Paging Bar"] = true,
			["Pet Bar"] = true,
			["Stance Bar"] = true,
			["Status Bars"] = true,
		},
		["Rescale"] = 1,
		["Resize"] = 24,
		["Reposition"] = true,
	},
	["Bag Frames"] = {
		["Circular"] = "Mechanical",
		["Rectangular"] = "Darkmoon",
		["Vertical"] = "Mechanical",
		["Rescale"] = 1,
		["Reposition"] = true,
	},
	["General Frames"] = {
		["Circular"] = "Mechanical",
		["Rectangular"] = "Darkmoon",
		["Scriptural"] = "Starcraft",
		["Vertical"] = "Mechanical",
		["Rescale"] = 1,
		["Reposition"] = true,
	},
	["Minimap"] = {
		["Horizontal"] = "Mechanical",
		["Rectangular"] = "Darkmoon",
		["Rescale"] = 1,
		["Reposition"] = true,
	},
	["Unit Frames"] = {
		["Circular"] = "Mechanical",
		["Horizontal"] = "Mechanical",
		["Rectangular"] = "Darkmoon",
		["Rescale"] = 1,
		["Reposition"] = true,
	},
}

local menuTbl = {
	{
		text = "Wind Trader",
		hasArrow = true,
		notCheckable = true,
		minWidth = 100,
		menuList = {
			{
				text = UnitFactionGroup("player") == "Alliance" and "Thaumaturge Vashreen" or "Thaumaturge Zajir",
				icon = "Interface/HelpFrame/HelpIcon-Suggestion",
				isNotRadio = true,
				keepShownOnClick = true,
				tCoordLeft = 0.1,
				tCoordRight = 0.9,
				tCoordTop = 0.1,
				tCoordBottom = 0.9,
				func = function()
					AltUISVPC["Wind Trader"]["ServiceNPC2"] = not AltUISVPC["Wind Trader"]["ServiceNPC2"]
					UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
					if AltUISVPC["Wind Trader"]["ServiceNPC1"] or AltUISVPC["Wind Trader"]["ServiceNPC2"] or AltUISVPC["Wind Trader"]["ServiceNPC3"] then
						AltModelFrame:Show()
						return
					end
					AltModelFrame:Hide()
				end,
				checked = function() return AltUISVPC["Wind Trader"]["ServiceNPC2"] end,
			},
			{
				text = UnitFactionGroup("player") == "Alliance" and "Vaultkeeper Razhid" or "Vaultkeeper Jazra",
				icon = "Interface/HelpFrame/HelpIcon-ReportLag",
				isNotRadio = true,
				keepShownOnClick = true,
				tCoordLeft = 0.1,
				tCoordRight = 0.9,
				tCoordTop = 0.1,
				tCoordBottom = 0.9,
				func = function()
					AltUISVPC["Wind Trader"]["ServiceNPC3"] = not AltUISVPC["Wind Trader"]["ServiceNPC3"]
					UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
					if AltUISVPC["Wind Trader"]["ServiceNPC1"] or AltUISVPC["Wind Trader"]["ServiceNPC2"] or AltUISVPC["Wind Trader"]["ServiceNPC3"] then
						AltModelFrame:Show()
						return
					end
					AltModelFrame:Hide()
				end,
				checked = function() return AltUISVPC["Wind Trader"]["ServiceNPC3"] end,
			},
			{
				text = UnitFactionGroup("player") == "Alliance" and "Warpweaver Hashom" or "Warpweaver Dushar",
				icon = "Interface/HelpFrame/HelpIcon-HotIssues",
				isNotRadio = true,
				keepShownOnClick = true,
				tCoordLeft = 0.1,
				tCoordRight = 0.9,
				tCoordTop = 0.1,
				tCoordBottom = 0.9,
				func = function()
					AltUISVPC["Wind Trader"]["ServiceNPC1"] = not AltUISVPC["Wind Trader"]["ServiceNPC1"]
					UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
					if AltUISVPC["Wind Trader"]["ServiceNPC1"] or AltUISVPC["Wind Trader"]["ServiceNPC2"] or AltUISVPC["Wind Trader"]["ServiceNPC3"] then
						AltModelFrame:Show()
						return
					end
					AltModelFrame:Hide()
				end,
				checked = function() return AltUISVPC["Wind Trader"]["ServiceNPC1"] end,
			},
		},
	},
	{
		text = "Warp Service",
		justifyH = "CENTER",
		isTitle = true,
		notCheckable = true,
		menuList = {
		},
	},
	{
		text = "Action Bar",
		hasArrow = true,
		notCheckable = true,
		menuList = {
			{
				text = "Transmogrify",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
				minWidth = 103,
			},
			{
				text = "Classical",
				hasArrow = true,
				notCheckable = true,
				menuList = {
					{
						text = "Action Bar",
						icon = "Interface/HelpFrame/HelpIcon-ItemRestoration",
						isNotRadio = true,
						keepShownOnClick = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						func = function()
							if not InCombatLockdown() then
								AltUISVPC["Action Bar"]["Classical"]["Action Bar"] = not AltUISVPC["Action Bar"]["Classical"]["Action Bar"]
								AltUI_PlaySoundFile(AltUISVPC["Action Bar"]["Classical"]["Action Bar"], true)
								AltActionBar_SetState()
							end
							UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
						end,
						checked = function() return AltUISVPC["Action Bar"]["Classical"]["Action Bar"] end,
					},
					{
						text = "Casting Bar",
						icon = "Interface/HelpFrame/ReportLagIcon-Spells",
						isNotRadio = true,
						keepShownOnClick = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						isNotRadio = true,
						keepShownOnClick = true,
						func = function() 
							AltUISVPC["Action Bar"]["Classical"]["Casting Bar"] = not AltUISVPC["Action Bar"]["Classical"]["Casting Bar"]
							AltUI_PlaySoundFile(AltUISVPC["Action Bar"]["Classical"]["Casting Bar"], true)
							AltActionBar_CastingBar_SetState()
							UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
						end,
						checked = function() return AltUISVPC["Action Bar"]["Classical"]["Casting Bar"] end,
					},
				},
			},
			{
				text = "Horizontal",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Rectangular",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Modification",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
			},
			{
				text = "Reforge",
				hasArrow = true,
				notCheckable = true,
				menuList = {
					{
						text = "Bag Slots",
						icon = "Interface/HelpFrame/ReportLagIcon-Loot",
						isNotRadio = true,
						keepShownOnClick = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						func = function() 
							if not InCombatLockdown() then
								AltUISVPC["Action Bar"]["Reforge"]["Bag Slots"] = not AltUISVPC["Action Bar"]["Reforge"]["Bag Slots"]
								AltUI_PlaySoundFile(AltUISVPC["Action Bar"]["Reforge"]["Bag Slots"])
								if AltActionBar:IsShown() then
									AltActionBar_CalcSize()
								end
							end
							UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
						end,
						checked = function() return AltUISVPC["Action Bar"]["Reforge"]["Bag Slots"] end,
					},
					{
						text = "Paging Bar",
						icon = "Interface/HelpFrame/HelpIcon-CharacterStuck",
						isNotRadio = true,
						keepShownOnClick = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						func = function()
							if not InCombatLockdown() then
								AltUISVPC["Action Bar"]["Reforge"]["Paging Bar"] = not AltUISVPC["Action Bar"]["Reforge"]["Paging Bar"]
								AltUI_PlaySoundFile(AltUISVPC["Action Bar"]["Reforge"]["Paging Bar"])
								if AltActionBar:IsShown() then
									AltActionBar_CalcSize()
								end
							end
							UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
						end,
						checked = function() return AltUISVPC["Action Bar"]["Reforge"]["Paging Bar"] end,
					},
					{
						text = "Pet Bar",
						icon = "Interface/HelpFrame/HelpIcon-Bug",
						isNotRadio = true,
						keepShownOnClick = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						func = function()
							if not InCombatLockdown() then
								AltUISVPC["Action Bar"]["Reforge"]["Pet Bar"] = not AltUISVPC["Action Bar"]["Reforge"]["Pet Bar"]
								AltUI_PlaySoundFile(AltUISVPC["Action Bar"]["Reforge"]["Pet Bar"])
								AltActionBar_PetBar_SetScale()
							end
							UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
						end,
						checked = function() return AltUISVPC["Action Bar"]["Reforge"]["Pet Bar"] end,
					},
					{
						text = "Stance Bar",
						icon = "Interface/HelpFrame/HelpIcon-AccountSecurity",
						isNotRadio = true,
						keepShownOnClick = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						func = function()
							if not InCombatLockdown() then
								AltUISVPC["Action Bar"]["Reforge"]["Stance Bar"] = not AltUISVPC["Action Bar"]["Reforge"]["Stance Bar"]
								AltUI_PlaySoundFile(AltUISVPC["Action Bar"]["Reforge"]["Stance Bar"])
								AltActionBar_StanceBar_SetScale()
							end
							UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
						end,
						checked = function() return AltUISVPC["Action Bar"]["Reforge"]["Stance Bar"] end,
					},
					{
						text = "Status Bars",
						icon = "Interface/HelpFrame/ReportLagIcon-Chat",
						isNotRadio = true,
						keepShownOnClick = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						func = function()
							if not InCombatLockdown() then
								AltUISVPC["Action Bar"]["Reforge"]["Status Bars"] = not AltUISVPC["Action Bar"]["Reforge"]["Status Bars"]
								AltUI_PlaySoundFile(AltUISVPC["Action Bar"]["Reforge"]["Status Bars"])
								if AltActionBar:IsShown() then
									AltActionBar_CalcSize()
								end
							end
							UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
						end,
						checked = function() return AltUISVPC["Action Bar"]["Reforge"]["Status Bars"] end,
					},
				},
			},
			{
				text = "Rescale",
				value = "Action Bar,Rescale",
				hasArrow = true,
				notCheckable = true,
				menuList = {
					{
						text = "",
						notCheckable = true,
						disabled = true,
					},
				},
			},
			{
				text = "Resize",
				value = "Action Bar,Resize",
				hasArrow = true,
				notCheckable = true,
				menuList = {
					{
						text = "",
						notCheckable = true,
						disabled = true,
					},
				},
			},
			{
				text = "Reposition",
				icon = "Interface/HelpFrame/ReportLagIcon-Movement",
				isNotRadio = true,
				keepShownOnClick = true,
				tCoordLeft = 0.1,
				tCoordRight = 0.9,
				tCoordTop = 0.1,
				tCoordBottom = 0.9,
				func = function()
					if not InCombatLockdown() then
						AltUISVPC["Action Bar"]["Reposition"] = not AltUISVPC["Action Bar"]["Reposition"]
						AltUI_PlaySoundFile(AltUISVPC["Action Bar"]["Reposition"])
						AltActionBar_Reposition()
					end
					UIDropDownMenu_Refresh(AltMinimapButtonDropDown, nil, 2)
				end,
				checked = function() return AltUISVPC["Action Bar"]["Reposition"] end,
			},
		},
		frameList = {
			"AltActionBar",
		},
	},
	{
		text = "Bag Frames",
		hasArrow = true,
		notCheckable = true,
		menuList = {
			{
				text = "Transmogrify",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
				minWidth = 103,
			},
			{
				text = "Circular",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Rectangular",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Vertical",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Modification",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
			},
			{
				text = "Rescale",
				value = "Bag Frames,Rescale",
				hasArrow = true,
				notCheckable = true,
				menuList = {
					{
						text = "",
						notCheckable = true,
						disabled = true,
					},
				},
			},
			{
				text = "Reposition",
				icon = "Interface/HelpFrame/ReportLagIcon-Movement",
				isNotRadio = true,
				keepShownOnClick = true,
				tCoordLeft = 0.1,
				tCoordRight = 0.9,
				tCoordTop = 0.1,
				tCoordBottom = 0.9,
				func = function()
					AltUISVPC["Bag Frames"]["Reposition"] = not AltUISVPC["Bag Frames"]["Reposition"]
					AltUI_PlaySoundFile(AltUISVPC["Bag Frames"]["Reposition"])
					AltContainerFrame_Reposition()
				end,
				checked = function() return AltUISVPC["Bag Frames"]["Reposition"] end,
			},
		},
		frameList = {
			"AltContainerFrame1",
			"AltContainerFrame2",
			"AltContainerFrame3",
			"AltContainerFrame4",
			"AltContainerFrame5",
			"AltContainerFrame6",
			"AltContainerFrame7",
			"AltContainerFrame8",
			"AltContainerFrame9",
			"AltContainerFrame10",
			"AltContainerFrame11",
			"AltContainerFrame12",
			"AltLootFrame",
		},
	},
	{
		text = "General Frames",
		hasArrow = true,
		notCheckable = true,
		menuList = {
			{
				text = "Transmogrify",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
				minWidth = 103,
			},
			{
				text = "Circular",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Rectangular",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Scriptural",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Vertical",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Modification",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
			},
			{
				text = "Reposition",
				icon = "Interface/HelpFrame/ReportLagIcon-Movement",
				isNotRadio = true,
				keepShownOnClick = true,
				tCoordLeft = 0.1,
				tCoordRight = 0.9,
				tCoordTop = 0.1,
				tCoordBottom = 0.9,
				func = function()
					AltUISVPC["General Frames"]["Reposition"] = not AltUISVPC["General Frames"]["Reposition"]
					AltUI_PlaySoundFile(AltUISVPC["General Frames"]["Reposition"])
					AltGeneralFrame_Reposition()
				end,
				checked = function() return AltUISVPC["General Frames"]["Reposition"] end,
			},
		},
		frameList = {
			"AltCharacterFrame",
			"AltSpellBookFrame",
			"AltQuestLogFrame",
			"AltQuestLogDetailFrame",
			"AltGossipFrame",
			"AltQuestFrame",
			"AltPlayerTalentFrame",
			"AltPetJournalParent",
			"AltPVPFrame",
			"AltPVEFrame",
			"AltLookingForGuildFrame",
			"AltEncounterJournal",
			"AltWorldMapFrame",
			"AltMerchantFrame",
			"AltMailFrame",
			"AltClassTrainerFrame",
			"AltMacroFrame",
			"AltInspectFrame",
			"AltGuildFrame",
			"AltAuctionFrame",
			"AltTaxiFrame",
			"AltBankFrame",
		},
	},
	{
		text = "Minimap",
		hasArrow = true,
		notCheckable = true,
		menuList = {
			{
				text = "Transmogrify",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
				minWidth = 103,
			},
			{
				text = "Horizontal",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Rectangular",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Modification",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
			},
			{
				text = "Rescale",
				value = "Minimap,Rescale",
				hasArrow = true,
				notCheckable = true,
				menuList = {
					{
						text = "",
						notCheckable = true,
						disabled = true,
					},
				},
			},
			{
				text = "Reposition",
				icon = "Interface/HelpFrame/ReportLagIcon-Movement",
				isNotRadio = true,
				keepShownOnClick = true,
				tCoordLeft = 0.1,
				tCoordRight = 0.9,
				tCoordTop = 0.1,
				tCoordBottom = 0.9,
				func = function()
					AltUISVPC["Minimap"]["Reposition"] = not AltUISVPC["Minimap"]["Reposition"]
					AltUI_PlaySoundFile(AltUISVPC["Minimap"]["Reposition"])
					AltMinimapFrame_Reposition()
				end,
				checked = function() return AltUISVPC["Minimap"]["Reposition"] end,
			},
		},
		frameList = {
			"AltMinimapFrame",
		},
	},
	{
		text = "Unit Frames",
		hasArrow = true,
		notCheckable = true,
		menuList = {
			{
				text = "Transmogrify",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
				minWidth = 103,
			},
			{
				text = "Circular",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Horizontal",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Rectangular",
				hasArrow = true,
				notCheckable = true,
			},
			{
				text = "Modification",
				justifyH = "CENTER",
				isTitle = true,
				notCheckable = true,
			},
			{
				text = "Rescale",
				value = "Unit Frames,Rescale",
				hasArrow = true,
				notCheckable = true,
				menuList = {
					{
						text = "",
						notCheckable = true,
						disabled = true,
					},
				},
			},
			{
				text = "Reposition",
				icon = "Interface/HelpFrame/ReportLagIcon-Movement",
				isNotRadio = true,
				keepShownOnClick = true,
				tCoordLeft = 0.1,
				tCoordRight = 0.9,
				tCoordTop = 0.1,
				tCoordBottom = 0.9,
				func = function()
					if not InCombatLockdown() then
						AltUISVPC["Unit Frames"]["Reposition"] = not AltUISVPC["Unit Frames"]["Reposition"]
						AltUI_PlaySoundFile(AltUISVPC["Unit Frames"]["Reposition"])
						AltUnitFrame_Reposition()
					end
					UIDropDownMenu_Refresh(AltMinimapButtonDropDown, nil, 2)
				end,
				checked = function() return AltUISVPC["Unit Frames"]["Reposition"] end,
			},
		},
		frameList = {
			"AltPlayerFrame",
			"AltTargetFrame",
			"AltFocusFrame",
		},
	},
	{
		text = "Void Storage",
		hasArrow = true,
		notCheckable = true,
		menuList = {
			{
				text = "Deposit",
				hasArrow = true,
				notCheckable = true,
				minWidth = 103,
				menuList = {
					{
						text = "Enter Set Name",
						notCheckable = true,
						isTitle = true,
					},
					{
						text = "",
						notCheckable = true,
						disabled = true,
					},
					{
						text = "",
						notCheckable = true,
						disabled = true,
					},
					{
						text = "Okay",
						icon = "Interface/HelpFrame/ReportLagIcon-AuctionHouse",
						notCheckable = true,
						keepShownOnClick = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						func = function()
							local text = AltMinimapButtonEditBox:GetText()
							if AltUISV["Void Storage"][text] then
								AltStaticPopupFrame.mode = "Deposit"
								AltStaticPopupFrame.selectedSet = text
								AltStaticPopupFrame:Show()
							else
								AltUI_DepositSkinSet(text)
								if AltModelFrame:IsShown() then
									PlaySound("UI_VoidStorage_Deposit")
								end
							end
						end,
					},
					{
						text = "Cancel",
						icon = "Interface/HelpFrame/ReportLagIcon-Mail",
						notCheckable = true,
						tCoordLeft = 0.1,
						tCoordRight = 0.9,
						tCoordTop = 0.1,
						tCoordBottom = 0.9,
						func = function() 
							AltMinimapButtonEditBox:SetText("")
						end,
					},
				},
			},
			{
				text = "Transfer",
				hasArrow = true,
				notCheckable = true,
				menuList = {
				},
			},
			{
				text = "Withdraw",
				hasArrow = true,
				notCheckable = true,
				menuList = {
				},
			},
		},
	},
}

function AltUI_SetSkin(info)
	for _, v in pairs(info.frameList) do
		local frame = _G[v]
		if frame == AltActionBar then
			local textureList = frame.textureList[info.value2]
			for _, v in pairs(textureList) do
				frame[v]:SetTexture(info.texture, frame[v]:GetHorizTile())
			end
		elseif info.value2 == "Rectangular" then
			frame.backgroundFrame.BackgroundTexture:Show()
			frame.backgroundFrame.BackgroundTexture:SetTexture(info.texture)
			frame.backgroundFrame.BackgroundTexture:SetHorizTile(info.horizTile)
			frame.backgroundFrame.BackgroundTexture:SetVertTile(info.vertTile)
			if info.isCropped then
				frame.backgroundFrame.BackgroundTexture:SetTexCoord(0, 1, 0.1738281, 0.3574219)
			else
				frame.backgroundFrame.BackgroundTexture:SetTexCoord(0, 1, 0, 1)
			end
		elseif info.value2 == "Circular" then
			if info.value1 == "Minimap" then
				AltMinimapFrame_SetCircularSkin(info)
			else
				frame.circularFrame.CircularTexture:Show()
				frame.circularFrame.CircularTexture:SetTexture(info.texture)
			end
		elseif info.value2 == "Horizontal" then
			local point, _, _, xOffset, yOffset = frame.horizontalFrame:GetPoint()
			if not frame.horizontalFrame.xOffset then
				frame.horizontalFrame.xOffset = xOffset
			end
			if info.text == "Bamboo" then
				frame.horizontalFrame:SetPoint(point, frame.horizontalFrame.xOffset+2.5, yOffset)
			else
				frame.horizontalFrame:SetPoint(point, frame.horizontalFrame.xOffset, yOffset)
			end
			frame.horizontalFrame.HorizontalTexture:Show()
			frame.horizontalFrame.HorizontalTexture:SetTexture(info.texture)
		elseif info.value2 == "Vertical" then
			frame.verticalFrame.VerticalTexture:Show()
			frame.verticalFrame.VerticalTexture:SetTexture(info.texture)
		end
	end
end

function AltUI_HideSkin(info)
	for _, v in pairs(info.frameList) do
		local frame = _G[v]
		if frame == AltActionBar then
			return
		elseif info.value2 == "Rectangular" then
			frame.backgroundFrame.BackgroundTexture:Hide()
		elseif info.value2 == "Circular" then
			if frame == AltMinimapFrame then
				AltMinimapFrame_HideCircularSkin(info)
			else
				frame.circularFrame.CircularTexture:Hide()
			end
		elseif info.value2 == "Horizontal" then
			frame.horizontalFrame.HorizontalTexture:Hide()
		elseif info.value2 == "Vertical" then		
			frame.verticalFrame.VerticalTexture:Hide()
		end
	end
end

function AltUI_AddSkinInfo(value1, value2, name, texture, arg1, arg2, arg3)
	for k, v in pairs(menuTbl) do
		if v.text == value1 then
			local info = {}
			info.text = name
			info.texture = texture
			info.frameList = v.frameList
			info.value1 = value1
			info.value2 = value2
			info.yOffset = arg1
			info.isCropped = arg1
			info.horizTile = arg2
			info.vertTile = arg3
			info.isSkin = true
			info.keepShownOnClick = true
			info.isNotRadio = true
			info.func = function()
				if info.value1 == "Action Bar" then
					if AltUISVPC[info.value1][info.value2] ~= name then
						AltUI_PlaySoundFile(true, true)
					end
					AltUISVPC[info.value1][info.value2] = name
					AltUI_SetSkin(info)
				elseif AltUISVPC[info.value1][info.value2] == name then
					AltUISVPC[info.value1][info.value2] = nil
					AltUI_HideSkin(info)
					AltUI_PlaySoundFile(false, true)
				else
					AltUISVPC[info.value1][info.value2] = name
					AltUI_SetSkin(info)
					AltUI_PlaySoundFile(true, true)
				end
				local selectedSet = AltUISVPC["Void Storage"]
				if selectedSet then
					AltUISV["Void Storage"][selectedSet][info.value1][info.value2] = AltUISVPC[info.value1][info.value2]
				else
					AltMinimapButtonDropDown.currentSet = nil
				end
				UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
			end
			info.checked = function()
				return AltUISVPC[info.value1][info.value2] == name
			end
			if info.value1 == "Minimap" and info.value2 == "Circular" and not v.hasCircular then
				v.hasCircular = true
				local tbl = {}
				tbl.text = "Circular"
				tbl.hasArrow = true
				tbl.notCheckable = true
				tinsert(v.menuList, 2, tbl)
			end
			for _, v in pairs(v.menuList) do
				if v.text == info.value2 then
					v.menuList = v.menuList or {}
					tinsert(v.menuList, info)
					sort(v.menuList, function(a, b) return a.text < b.text end)
				end
			end
		end
	end
	AltMinimapButtonDropDown.menuTbl = menuTbl
end

function AltUI_AddSkinSetInfo(name, value1, value2)
	for k, v in pairs(menuTbl) do
		if v.text == value1 then
			local info = {}
			info.text = name
			info.keepShownOnClick = true
			info.isNotRadio = true
			info.minWidth = 103
			info.func = function()
				if UIDROPDOWNMENU_MENU_VALUE == "Withdraw" then
					AltStaticPopupFrame.mode = "Withdraw"
					AltStaticPopupFrame.selectedSet = name
					AltStaticPopupFrame:Show()
				elseif AltUISVPC["Void Storage"] == name then
					AltUISVPC["Void Storage"] = nil
					AltMinimapButtonDropDown.currentSet = name
				else
					AltUISVPC["Void Storage"] = name
					if AltMinimapButtonDropDown.currentSet ~= name then
						AltUI_TransferSkinSet()
						if AltModelFrame:IsShown() then
							PlaySoundFile("Interface\\Addons\\AltUI\\Media\\UI_Transmogrify_Apply.OGG")
						end
					end
					AltMinimapButtonDropDown.currentSet = name
				end
				UIDropDownMenu_RefreshAll(AltMinimapButtonDropDown)
			end
			info.checked = function()
				return AltUISVPC["Void Storage"] == name
			end
			for _, v in pairs(v.menuList) do
				if v.text == value2 then
					v.menuList = v.menuList or {}
					tinsert(v.menuList, info)
					sort(v.menuList, function(a, b) return a.text < b.text end)
				end
			end
		end
	end
	AltMinimapButtonDropDown.menuTbl = menuTbl
end

function AltUI_AddFontInfo(value1, value2, name, font, scale)
	for k, v in pairs(menuTbl) do
		if v.text == value1 then
			local info = {}
			info.text = name
			info.font = font
			info.scale = scale
			info.value1 = value1
			info.value2 = value2
			info.isFont = true
			info.keepShownOnClick = true
			info.isNotRadio = true
			info.func = function()
				if AltUISVPC[info.value1][info.value2] == name then
					AltUISVPC[info.value1][info.value2] = nil
					AltUI_SetFont(nil)
				else
					AltUISVPC[info.value1][info.value2] = name
					AltUI_SetFont(info)
				end
				local selectedSet = AltUISVPC["Void Storage"]
				if selectedSet then
					AltUISV["Void Storage"][selectedSet][info.value1][info.value2] = AltUISVPC[info.value1][info.value2]
				else
					AltMinimapButtonDropDown.currentSet = nil
				end
				AltUI_PlaySoundFile(AltUISVPC[info.value1][info.value2], true)
				UIDropDownMenu_RefreshAll(AltMinimapButtonDropDown)
			end
			info.checked = function()
				return AltUISVPC[info.value1][info.value2] == name
			end
			for _, v in pairs(v.menuList) do
				if v.text == info.value2 then
					v.menuList = v.menuList or {}
					tinsert(v.menuList, info)
					sort(v.menuList, function(a, b) return a.text < b.text end)
				end
			end
		end
	end
end

function AltUI_AddRectangularInfo(name, texture, isActionBar, isCropped, vertTile, horizTile)
	if isActionBar then
		AltUI_AddSkinInfo("Action Bar", "Rectangular", name, texture)
		return
	end
	AltUI_AddSkinInfo("Bag Frames", "Rectangular", name, texture, isCropped, vertTile, horizTile)
	AltUI_AddSkinInfo("General Frames", "Rectangular", name, texture, isCropped, vertTile, horizTile)
	AltUI_AddSkinInfo("Minimap", "Rectangular", name, texture, isCropped, vertTile, horizTile)
	AltUI_AddSkinInfo("Unit Frames", "Rectangular", name, texture, isCropped, vertTile, horizTile)
end

function AltUI_AddCircularInfo(name, texture, isMinimap, yOffset)
	if isMinimap then
		AltUI_AddSkinInfo("Minimap", "Circular", name, texture, yOffset)
		return
	end
	AltUI_AddSkinInfo("Bag Frames", "Circular", name, texture)
	AltUI_AddSkinInfo("General Frames", "Circular", name, texture)
	AltUI_AddSkinInfo("Unit Frames", "Circular", name, texture)
end

function AltUI_AddHorizontalInfo(name, texture, isActionBar)
	if isActionBar then
		AltUI_AddSkinInfo("Action Bar", "Horizontal", name, texture)
		return
	end
	AltUI_AddSkinInfo("Bag Frames", "Vertical", name, texture)
	AltUI_AddSkinInfo("General Frames", "Vertical", name, texture)
	AltUI_AddSkinInfo("Minimap", "Horizontal", name, texture)
	AltUI_AddSkinInfo("Unit Frames", "Horizontal", name, texture)
end

function AltUI_AddScripturalInfo(name, font, scale)
	AltUI_AddFontInfo("General Frames", "Scriptural", name, font, scale)
end

function AltUI_SetFont(info)
	local font = info and info.font
	local scale = info and info.scale or 1
	local friz = font or "Fonts\\FRIZQT__.TTF"
	local morpheus = font or "Fonts\\MORPHEUS.TTF"
    for i=1, WorldFrame:GetNumChildren() do
        local v = select(i, WorldFrame:GetChildren())
		for i=1,v:GetNumRegions() do
			local v = select(i, v:GetRegions())
			if v:GetObjectType() == "FontString" then
				local font, size = v:GetFont()
				v:SetFont(friz, size)
			end
		end
    end
	NAMEPLATE_FONT = friz
	STANDARD_TEXT_FONT = friz
	CombatTextFont:SetFont(CombatTextFont:GetFont())
	SystemFont_Tiny:SetFont(friz, 9*scale)
	SystemFont_Small:SetFont(friz, 10*scale)
	SystemFont_Outline_Small:SetFont(friz, 10*scale, "OUTLINE")
	SystemFont_Outline:SetFont(friz, 13*scale, "OUTLINE")
	SystemFont_Shadow_Small:SetFont(friz, 10*scale)
	SystemFont_InverseShadow_Small:SetFont(friz, 10*scale)
	SystemFont_Med1:SetFont(friz, 12*scale)
	SystemFont_Shadow_Med1:SetFont(friz, 12*scale)
	SystemFont_Med2:SetFont(friz, 13*scale)
	SystemFont_Shadow_Med2:SetFont(friz, 13*scale)
	SystemFont_Med3:SetFont(friz, 14*scale)
	SystemFont_Shadow_Med3:SetFont(friz, 14*scale)
	SystemFont_Large:SetFont(friz, 16*scale)
	SystemFont_Shadow_Large:SetFont(friz, 16*scale)
	SystemFont_Huge1:SetFont(friz, 20*scale)
	SystemFont_Shadow_Huge1:SetFont(friz, 20*scale)
	SystemFont_OutlineThick_Huge2:SetFont(friz, 22*scale, "THICKOUTLINE")
	SystemFont_Shadow_Outline_Huge2:SetFont(friz, 22*scale, "OUTLINE")
	SystemFont_Shadow_Huge3:SetFont(friz, 25*scale)
	SystemFont_OutlineThick_Huge4:SetFont(friz, 26*scale, "THICKOUTLINE")
	SystemFont_OutlineThick_WTF:SetFont(friz, 32*scale, "THICKOUTLINE")
	QuestFont_Large:SetFont(morpheus, 15*scale)
	QuestFont_Shadow_Huge:SetFont(morpheus, 18*scale)
	QuestFont_Super_Huge:SetFont(morpheus, 24*scale)
	DestinyFontLarge:SetFont(morpheus, 18*scale)
	CoreAbilityFont:SetFont(morpheus, 32*scale)
	DestinyFontHuge:SetFont(morpheus, 32*scale)
	QuestFont_Shadow_Small:SetFont(morpheus, 14*scale)
	GameTooltipHeader:SetFont(friz, 14*scale)
	MailFont_Large:SetFont(morpheus, 15*scale)
	SpellFont_Small:SetFont(friz, 10*scale)
	InvoiceFont_Med:SetFont(friz, 12*scale)
	InvoiceFont_Small:SetFont(friz, 10*scale)
	Tooltip_Med:SetFont(friz, 12*scale)
	Tooltip_Small:SetFont(friz, 10*scale)
	AchievementFont_Small:SetFont(friz, 10*scale)
	ReputationDetailFont:SetFont(friz, 10*scale)
	FriendsFont_Normal:SetFont(friz, 12*scale)
	FriendsFont_Small:SetFont(friz, 10*scale)
	FriendsFont_Large:SetFont(friz, 14*scale)
	GameFont_Gigantic:SetFont(friz, 32*scale)
	WatchFrame_Update()
end

function AltUI_TableCopy(tbl)
	local t = {}
	for k, v in pairs(tbl) do
		if type(v) == "table" then
			t[k] = AltUI_TableCopy(v)
		else
			t[k] = v
		end
	end
	return t
end

function AltUI_CopySkinSet(tbl, key)
	local t = {}
	for k, v in pairs(tbl) do
		if type(v) == "table" and not key and k ~= "Wind Trader" and k ~= "Void Storage" then
			t[k] = AltUI_CopySkinSet(v, k)
		end
		if v == "GenericWow" then
			v = "Generic"
		end
		if v == "PandarenWood" or v == "PandarenTraining" then
			v = "Pandaren"
		end
		if k == "Background" then
			t["Rectangular"] = v
		end
		if k == "Circular" or k == "Horizontal" or k == "Rectangular" or k == "Vertical" or k == "Scriptural" then
			t[k] = v
		end
	end
	return t
end

function AltUI_DepositSkinSet(name, overwrite)
	AltUISV["Void Storage"][name] = AltUI_CopySkinSet(AltUISVPC)
	AltUISVPC["Void Storage"] = name
	AltMinimapButtonDropDown.currentSet = name
	if not overwrite then
		AltUI_AddSkinSetInfo(name, "Void Storage", "Transfer")
		AltUI_AddSkinSetInfo(name, "Void Storage", "Withdraw")
	end
	AltMinimapButtonEditBox:SetText("")
	CloseDropDownMenus(UIDROPDOWNMENU_MENU_LEVEL)
end

function AltUI_WithdrawSkinSet(name)
	local transferList = menuTbl[#menuTbl].menuList[2].menuList
	local withdrawList = menuTbl[#menuTbl].menuList[3].menuList
	for i, v in pairs(withdrawList) do
		if v.text == name then
			AltUISV["Void Storage"][name] = nil
			if AltUISVPC["Void Storage"] == v.text then
				AltUISVPC["Void Storage"] = nil
				AltMinimapButtonDropDown.currentSet = nil
			end
			tremove(transferList, i)
			tremove(withdrawList, i)
		end
	end
	sort(transferList, function(a, b) return a.text < b.text end)
	sort(withdrawList, function(a, b) return a.text < b.text end)
	CloseDropDownMenus(UIDROPDOWNMENU_MENU_LEVEL)
end

function AltUI_TransferSkinSet()
	local selectedSet = AltUISVPC["Void Storage"]
	local tbl = AltUISV["Void Storage"][selectedSet] or AltUISVPC
	for _, v in pairs(menuTbl) do
		for _, v in pairs(v.menuList) do
			if v.menuList then
				for i, v in pairs(v.menuList) do
					if v.isSkin or v.isFont then
						if i == 1 and v.isSkin then
							AltUI_HideSkin(v)
						elseif i == 1 and v.isFont then
							AltUI_SetFont(nil)
						end
						if not tbl[v.value1][v.value2] then
							AltUISVPC[v.value1][v.value2] = nil
						elseif tbl[v.value1][v.value2] == v.text then
							AltUISVPC[v.value1][v.value2] = v.text
							if v.isSkin then
								AltUI_SetSkin(v)
							elseif v.isFont then
								AltUI_SetFont(v)
							end
						end
					end
				end
			end
		end
	end
end

function AltUI_PlaySoundFile(apply, isSkin)
	if not AltModelFrame:IsShown() then
		return
	end
	if apply and isSkin then
		PlaySoundFile("Sound\\Interface\\UI_VoidStorage_Redo.OGG")
	elseif apply then
		PlaySoundKitID(23291)
	elseif isSkin then
		PlaySoundFile("Sound\\Interface\\UI_VoidStorage_Undo.OGG")
	else
		PlaySoundKitID(23292)
	end
end

function AltMinimapButtonDropDown_OnLoad(self)
	self.noResize = true
	self.point = "TOPRIGHT"
	self:RegisterEvent("VARIABLES_LOADED")
end

function AltMinimapButtonDropDown_OnEvent(self, event, ...)
	if event == "VARIABLES_LOADED" then
		if AltUIMenu then
			AltUISV = {}
			AltUISV["Version"] = 2.72
			AltUISV["Void Storage"] = AltUI_TableCopy(AltUIMenu["Void Storage"])
			AltUISV["Music Volume"] = GetCVar("Sound_MusicVolume")
			AltUISVPC = AltUI_TableCopy(AltUIMenu)
			AltUIMenu = nil
			ALTUI_VERSION = nil
			ALTUI_MUSIC_VOLUME = nil
		end
		if AltUI_SV then
			AltUISV = {}
			AltUISV["Version"] = 2.72
			local tbl = {}
			for k, v in pairs(AltUI_SV) do
				tbl[k] = AltUI_CopySkinSet(v)
			end
			AltUISV["Void Storage"] = tbl
			AltUISV["Music Volume"] = GetCVar("Sound_MusicVolume")
			AltUI_SV = nil
		end
		if not AltUISV then
			AltUISV = {}
			AltUISV["Void Storage"] = {}
			AltUISV["Version"] = 2.72
			AltUISV["Music Volume"] = GetCVar("Sound_MusicVolume")
		end
		if not AltUISVPC then
			AltUISVPC = defaultsTbl
		end
		if ALTUI_SELECTED_SET then
			AltUISVPC["Void Storage"] = ALTUI_SELECTED_SET
			ALTUI_SELECTED_SET = nil
		end
		if AltUI_SVPC then
			if AltUI_SVPC.selectedSet then
				AltUISVPC["Void Storage"] = AltUI_SVPC.selectedSet
			end
			AltUI_SVPC = nil
		end
		local selectedSet = AltUISVPC["Void Storage"]
		if selectedSet and not AltUISV["Void Storage"][selectedSet] then
			AltUISVPC["Void Storage"] = nil
		end
		for k, v in pairs(AltUISV["Void Storage"]) do
			AltUI_AddSkinSetInfo(k, "Void Storage", "Transfer")
			AltUI_AddSkinSetInfo(k, "Void Storage", "Withdraw")
		end
		SetCVar("Sound_MusicVolume", AltUISV["Music Volume"])
		AltUI_TransferSkinSet()
	end
end

function AltMinimapButtonSlider_OnValueChanged(self, value)
	local value1 = self.value1
	local value2 = self.value2
	if value2 == "Resize" then
		AltUISVPC[value1][value2] = value
		if AltActionBar:IsShown() then
			AltActionBar_CalcSize()
		end
		if self.playSound and AltModelFrame:IsShown() then
			if value > self.lastValue then
				PlaySoundKitID(23291)
			else
				PlaySoundKitID(23292)
			end
		end
	end
	if value2 == "Rescale" then
		AltUISVPC[value1][value2] = value
		if value1 == "Action Bar" then
			AltActionBar_SetScale()
		elseif value1 == "Bag Frames" then
			AltContainerFrame_UpdateAnchors()
		elseif value1 == "Minimap" then
			AltMinimapFrame_Rescale()
			if AltModelFrame:IsShown() then
				AltModelFrame.model:SetCreature(AltModelFrame.currentID)
			end
		elseif value1 == "Unit Frames" then
			AltUnitFrame_Rescale()
		end
		if self.playSound and AltModelFrame:IsShown() then
			if value > self.lastValue then
				PlaySoundKitID(23291)
			else
				PlaySoundKitID(23292)
			end
		end
		return
	end
	if value2 == nil then
		for i=1, self.parent.numButtons do
			local button = _G["DropDownList3Button"..i]
			if not button.yOffset then
				local point, _, _, xOffset, yOffset = button:GetPoint()
				button.xOffset = xOffset
				button.yOffset = yOffset
			end
			if i < value or i > value + 7 then
				button:Hide()
			else
				button:Show()
				button:SetPoint("TOPLEFT", button.xOffset, button.yOffset+((value-1)*16))
			end
		end
	end
	UIDropDownMenu_Refresh(AltMinimapButtonDropDown)
end