function AltContainerFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED")
end

function AltContainerFrame_OnEvent(self)
	UpdateContainerFrameAnchors = AltContainerFrame_UpdateAnchors
	AltContainerFrame_Reposition()
	AltContainerFrame_UpdateAnchors()	
end

function AltContainerFrame_Reposition()
	local numContainerFrames = 12
	for i=1, numContainerFrames do
		local altFrame = _G["AltContainerFrame"..i]
		local frame = _G["ContainerFrame"..i]
		local portrait = _G[frame:GetName().."Portrait"]
		local name = _G[frame:GetName().."Name"]
		if AltUISVPC["Bag Frames"]["Reposition"] then
			CONTAINER_SPACING = 16
			VISIBLE_CONTAINER_SPACING = 19
			CONTAINER_WIDTH = 208
			portrait:SetPoint(unpack(portrait.altPos))
			name:SetPoint(unpack(name.altPos))
			altFrame.backgroundFrame:SetPoint(unpack(altFrame.backgroundFrame.altPos))
			altFrame.circularFrame:SetPoint(unpack(altFrame.circularFrame.altPos))
			altFrame.verticalFrame:SetPoint(unpack(altFrame.verticalFrame.altPos))
		else
			CONTAINER_SPACING = 0
			VISIBLE_CONTAINER_SPACING = 3
			CONTAINER_WIDTH = 192
			portrait:SetPoint(unpack(portrait.defaultPos))
			name:SetPoint(unpack(name.defaultPos))
			altFrame.backgroundFrame:SetPoint(unpack(altFrame.backgroundFrame.defaultPos))
			altFrame.circularFrame:SetPoint(unpack(altFrame.circularFrame.defaultPos))
			altFrame.verticalFrame:SetPoint(unpack(altFrame.verticalFrame.defaultPos))
		end
		if frame:IsShown() then
			CloseBag(frame:GetID())
			OpenBag(frame:GetID())
		end
	end
end

function AltContainerFrame_UpdateAnchors()
	local frame, xOffset, yOffset, screenHeight, freeScreenHeight, leftMostPoint, column;
	local screenWidth = GetScreenWidth();
	local containerScale = AltUISVPC["Bag Frames"]["Rescale"] or 1
	local leftLimit = 0;
	if ( BankFrame:IsShown() ) then
		leftLimit = BankFrame:GetRight() - 25;
	end
	
	while ( containerScale > CONTAINER_SCALE ) do
		screenHeight = GetScreenHeight() / containerScale;
		-- Adjust the start anchor for bags depending on the multibars
		xOffset = CONTAINER_OFFSET_X / containerScale; 
		yOffset = CONTAINER_OFFSET_Y / containerScale; 
		-- freeScreenHeight determines when to start a new column of bags
		freeScreenHeight = screenHeight - yOffset;
		leftMostPoint = screenWidth - xOffset;
		column = 1;
		local frameHeight;
		for index, frameName in ipairs(ContainerFrame1.bags) do
			frameHeight = _G[frameName]:GetHeight();
			if ( freeScreenHeight < frameHeight ) then
				-- Start a new column
				column = column + 1;
				leftMostPoint = screenWidth - ( column * CONTAINER_WIDTH * containerScale ) - xOffset;
				freeScreenHeight = screenHeight - yOffset;
			end
			freeScreenHeight = freeScreenHeight - frameHeight - VISIBLE_CONTAINER_SPACING;
		end
		if ( leftMostPoint < leftLimit ) then
			containerScale = containerScale - 0.01;
		else
			break;
		end
	end
	
	if ( containerScale < CONTAINER_SCALE ) then
		containerScale = CONTAINER_SCALE;
	end
	
	screenHeight = GetScreenHeight() / containerScale;
	-- Adjust the start anchor for bags depending on the multibars
	xOffset = CONTAINER_OFFSET_X / containerScale;
	yOffset = CONTAINER_OFFSET_Y / containerScale;
	-- freeScreenHeight determines when to start a new column of bags
	freeScreenHeight = screenHeight - yOffset;
	column = 0;
	for index, frameName in ipairs(ContainerFrame1.bags) do
		frame = _G[frameName];
		frame:SetScale(containerScale);
		if ( index == 1 ) then
			-- First bag
			frame:SetPoint("BOTTOMRIGHT", frame:GetParent(), "BOTTOMRIGHT", -xOffset, yOffset );
		elseif ( freeScreenHeight < frame:GetHeight() ) then
			-- Start a new column
			column = column + 1;
			freeScreenHeight = screenHeight - yOffset;
			frame:SetPoint("BOTTOMRIGHT", frame:GetParent(), "BOTTOMRIGHT", -(column * CONTAINER_WIDTH) - xOffset, yOffset );
		else
			-- Anchor to the previous bag
			frame:SetPoint("BOTTOMRIGHT", ContainerFrame1.bags[index - 1], "TOPRIGHT", 0, CONTAINER_SPACING);	
		end
		freeScreenHeight = freeScreenHeight - frame:GetHeight() - VISIBLE_CONTAINER_SPACING;
	end
end