local frameList = {
	"AltCharacterFrame",
	"AltSpellBookFrame",
	"AltQuestLogFrame",
	"AltGossipFrame",
	"AltQuestFrame",
	"AltPlayerTalentFrame",
	"AltPetJournalParent",
	"AltPVPFrame",
	"AltPVEFrame",
	"AltLookingForGuildFrame",
	"AltEncounterJournal",
	"AltWorldMapFrame",
	"AltMerchantFrame",
	"AltMailFrame",
	"AltClassTrainerFrame",
	"AltMacroFrame",
	"AltInspectFrame",
	"AltGuildFrame",
	"AltAuctionFrame",
	"AltTaxiFrame",
	"AltBankFrame",	
}

function AltGeneralFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED")
end

function AltGeneralFrame_OnEvent(self)
	AltGeneralFrame_Reposition()
end

function AltGeneralFrame_Reposition()
	for k, v in pairs(frameList) do
		local parent = _G[v]:GetParent()
		if parent and parent:IsShown() then
			UpdateUIPanelPositions(parent)
		end
	end
end

function AltGeneralFrame_ManagePosition(frame)
	hooksecurefunc(frame, "SetPoint", function(self, ...)
		if self:IsProtected() and InCombatLockdown() then 
			return
		end
		if not self.ignore and AltUISVPC["General Frames"]["Reposition"] then
			local point, relativeTo, relativePoint, xOffset, yOffset = self:GetPoint()
			self.ignore = true
			if frame == AuctionFrame then
				self:SetPoint(point, relativeTo, relativePoint, xOffset+16, yOffset)
			elseif frame == PetJournalParent then
				self:SetPoint(point, relativeTo, relativePoint, xOffset+32, yOffset-16)
			else
				self:SetPoint(point, relativeTo, relativePoint, xOffset+32, yOffset)
			end
			self.ignore = false
		end
	end)
end