local faction = UnitFactionGroup("player")
if faction == "Alliance" then
	name1, name2, name3 = "Warpweaver Hashom", "Thaumaturge Vashreen", "Vaultkeeper Razhid"
	id1, id2, id3 = 54442, 54441, 54443
else
	name1, name2, name3 = "Warpweaver Dushar", "Thaumaturge Zajir", "Vaultkeeper Jazra"
	id1, id2, id3 = 54473, 54471, 54472
end

local modelTbl = {
	{
		name = name1,
		id = id1,
		spec = "Transmogrifier",
		sound = {
			{
				file = "Sound\\Creature\\EtherealServiceNPC1\\VO_ETHEREALNPC1GREETING01.OGG",
				duration = 3.290,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC1\\VO_ETHEREALNPC1GREETING02.OGG",
				duration = 3.314,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC1\\VO_ETHEREALNPC1GREETING03.OGG",
				duration = 4.319,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC1\\VO_ETHEREALNPC1GREETING04.OGG",
				duration = 4.874,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC1\\VO_ETHEREALNPC1GREETING05.OGG",
				duration = 3.190,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC1\\VO_ETHEREALNPC1PISSED01.OGG",
				duration = 4.960,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC1\\VO_ETHEREALNPC1PISSED02.OGG",
				duration = 4.168,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC1\\VO_ETHEREALNPC1PISSED03.OGG",
				duration = 6.448,
			},
		},
	},
	{
		name = name2,
		id = id2,
		spec = "Arcane Reforger",
		sound = {
			{
				file = "Sound\\Creature\\EtherealServiceNPC2\\VO_ETHEREALNPC2GREETING01.OGG",
				duration = 3.603,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC2\\VO_ETHEREALNPC2GREETING02.OGG",
				duration = 3.795,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC2\\VO_ETHEREALNPC2GREETING03.OGG",
				duration = 4.484,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC2\\VO_ETHEREALNPC2GREETING04.OGG",
				duration = 5.164,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC2\\VO_ETHEREALNPC2GREETING05.OGG",
				duration = 3.809,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC2\\VO_ETHEREALNPC2PISSED01.OGG",
				duration = 4.939,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC2\\VO_ETHEREALNPC2PISSED02.OGG",
				duration = 3.914,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC2\\VO_ETHEREALNPC2PISSED03.OGG",
				duration = 5.349,
			},
		},
	},
	{
		name = name3,
		id = id3,
		spec = "Void Storage",
		sound = {
			{
				file = "Sound\\Creature\\EtherealServiceNPC3\\VO_ETHEREALNPC3GREETING01.OGG",
				duration = 3.716,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC3\\VO_ETHEREALNPC3GREETING02.OGG",
				duration = 3.580,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC3\\VO_ETHEREALNPC3GREETING03.OGG",
				duration = 5.781,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC3\\VO_ETHEREALNPC3GREETING04.OGG",
				duration = 5.948,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC3\\VO_ETHEREALNPC3GREETING05.OGG",
				duration = 4.096,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC3\\VO_ETHEREALNPC3PISSED01.OGG",
				duration = 5.207,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC3\\VO_ETHEREALNPC3PISSED02.OGG",
				duration = 4.121,
			},
			{
				file = "Sound\\Creature\\EtherealServiceNPC3\\VO_ETHEREALNPC3PISSED03.OGG",
				duration = 8.107,
			},
		},
	},
}

function AltUnitFrame_OnLoad(self)
	AltModelFrame.modelTbl = AltModelFrame_TableCopy(modelTbl)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function AltUnitFrame_OnEvent(self)
	AltUnitFrame_Reposition()
	AltUnitFrame_Rescale()
end

function AltModelFrame_TableCopy(tbl)
	local t = {}
	for k, v in pairs(tbl) do
		if type(v) == "table" then
			t[k] = AltModelFrame_TableCopy(v)
		else		
			t[k] = v
		end
	end
	return t
end

function AltModelFrame_Update(self, onshow)
	local tbl = self.modelTbl
	local index = self.currentIndex or random(1, #tbl)
	local indexTbl = self.modelTbl[index]
	local numSounds = #indexTbl.sound
	local isSelected = AltUISVPC["Wind Trader"]["ServiceNPC"..index]
	if not isSelected then
		self.currentIndex = nil
		AltModelFrame_Update(self, true)
		return
	end
	if onshow then
		self.currentIndex = index
		self.currentName = indexTbl.name
		self.currentSpec = indexTbl.spec
		self.currentID = indexTbl.id
		self.model:SetCreature(indexTbl.id)
	end
	if self.lastDuration > GetTime() then
		return
	end
	if numSounds > 3 then
		local index = random(1, numSounds-3)
		self.lastDuration = indexTbl.sound[index].duration + GetTime()
		PlaySoundFile(indexTbl.sound[index].file)
		tremove(indexTbl.sound, index)
	elseif numSounds > 0 and not onshow then
		local index = random(1, numSounds)
		self.lastDuration = indexTbl.sound[index].duration + GetTime()
		PlaySoundFile(indexTbl.sound[index].file)
		tremove(indexTbl.sound, index)
	elseif onshow then
		tremove(tbl, index)
		tinsert(tbl, index, AltModelFrame_TableCopy(modelTbl[index]))
		AltModelFrame_Update(self)
	end
end

function AltUnitFrame_Reposition()
	if AltUISVPC["Unit Frames"]["Reposition"] then
		if not PlayerFrame:IsUserPlaced() then
			PlayerFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -3, -20)
		end
		if not TargetFrame:IsUserPlaced() then
			TargetFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 298, -20)
		end
	else
		if not PlayerFrame:IsUserPlaced() then
			PlayerFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -19, -4)
		end
		if not TargetFrame:IsUserPlaced() then
			TargetFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 250, -4)
		end
	end
end

function AltUnitFrame_Rescale()
	local scale = AltUISVPC["Unit Frames"]["Rescale"]
	PlayerFrame:SetScale(scale)
	TargetFrame:SetScale(scale)
	FocusFrame:SetScale(scale)
	AltActionBar_CastingBar_SetScale()
end